#include <graphics.h>
#include <iostream>

/******************************************************************************/
/* Ponizszy przyklad pokazuje dwa sposoby obslugi myszy w programach          */
/* pisanych z wykorzystaniem biblioteki WinBGIm                               */
/******************************************************************************/

// Ta funkcja bedzie wywolywana automatycznie przez system. Kiedy? O tym 
// zdecydujemy w pozniej.
void ButtonDown_handler(int x, int y)
{
 setfillstyle(SOLID_FILL, RED);
 setcolor(WHITE);
 bar(410,5,430,25);
 rectangle(410,5,430,25);
 outtextxy(8,8,"Wcisnieto klawisz myszy          ");
}

// Ta funkcja rowniez bedzie wywolywana przez system.
void ButtonUp_handler(int x, int y)
{
 setfillstyle(SOLID_FILL, YELLOW);
 setcolor(WHITE);
 bar(410,5,430,25); 
 rectangle(410,5,430,25);
 outtextxy(8,8,"ZWOLNIONO KLAWISZ MYSZY"); 
}

int main(void)
{
 int x,y;
// Tworzymy nowe okno dla trybu graficznego 
 initwindow(450, 300);         
// Rejestrujemy w systemie procedure ButtonDown_handler jako procedure
// obslugujaca zdarzenie polegajace na wcisnieciu lewego klawisza myszy.
// Od tej pory za kazdym razem, gdy uzytkownik wcisnie lewy klawisz myszy
// system automatycznie wywola i wykona nasza funkcje. Zupelnie bez naszego
// udzialu. 
 registermousehandler(WM_LBUTTONDOWN, ButtonDown_handler);
// Podobnie rejestrujemy w systemie funkcje ButtonUp_handler jako funkcje
// obslugujaca zwolnienie lewego klawisza myszy. 
 registermousehandler(WM_LBUTTONUP, ButtonUp_handler);

// Petla bedzie wykonywana dopoki uzytkownik nie wykona podwojnego klikniecia 
// lewym klawiszem myszy.
 while (!ismouseclick(WM_LBUTTONDBLCLK))
 {
  if (ismouseclick(WM_RBUTTONUP))
  {
// Jezeli zwolniono prawy klawisz myszy to pobieramy informacje o wspolrzednych
// punktu, w ktorym nastapilo zwolnienie klawisza.
// Zwrocmy uwage, ze tym razem w odroznieniu od funkcji-handlerow, 
// programista sam musi zadbac o sprawdzenie czy dane zdarzenie wystapilo, 
// a jesli tak to sam musi wywolac kod, ktory to zdarzenie obsluzy.
   getmouseclick(WM_RBUTTONUP,x,y);
// Wypisujemy tekst "UP" w miejscu, gdzie zwolniono klawisz myszy.   
   outtextxy(x,y,"UP");
  }
// Pobieramy informacje o aktualnym polozeniu mysz ...
  x=mousex();
  y=mousey();
// ... i stawiamy punkt w miejscu, w ktorym mysza sie znajduje.
  putpixel(x,y,WHITE);
//  delay(1);
 }

 closegraph();
}

